/*
 * eth.h
 *
 *  Created on: 2012/01/02
 *      Author: Kentaro Sekimoto
 */

#ifndef ETH_H_
#define ETH_H_
#include "ip.h"

#define ETHARP_HWADDR_LEN	6
#define ETH_PACKET_SIZE	1536

struct eth_addr {
  unsigned char addr[ETHARP_HWADDR_LEN];
};

struct eth_hdr {
  struct eth_addr dst;
  struct eth_addr src;
  unsigned short type;
};

struct eth_packet {
	struct eth_hdr ehdr;
	unsigned char data[ETH_PACKET_SIZE];
};

struct etharp_hdr {
	unsigned short hwtype;			// 00
	unsigned short proto;			// 02
	unsigned short _hwlen_protolen;	// 04
	unsigned short opcode;			// 06
	struct eth_addr shwaddr;		// 08
	struct ip_addr1 sipaddr;		// 0E
	struct eth_addr dhwaddr;		// 12
	struct ip_addr1 dipaddr;		// 18
};

#endif /* ETH_H_ */
