/*
 * fm3_exti.c
 *
 *  Created on: 2012/03/04
 *      Author: Kentaro Sekimoto
 */

#include "common.h"
#include "mcu.h"
#include "fm3_ether.h"
#include "fm3_exti.h"
#include "phy.h"
#include "debug_printf.h"

void EXTI_Init(void)
{
	//debug_printf("EXTI_Init()\n");
	FM3_GPIO->PFRA |= 0x00000030;	// PA4, PA5Ӄsݒ
	FM3_GPIO->EPFR06 = 0x00300000;	// INT03_0, INT10_2I
	FM3_EXTI->ENIR = 0x00000000;	// O݋WX^NA
	FM3_EXTI->ELVR = 0x00200080;	// OݗvxWX^INT3, INT10 GbWo
	FM3_EXTI->EICL = 0x00000000;	// OݗvNAWX^NA
	FM3_EXTI->ENIR = 0x00000408;	// O݋WX^INT03, INT10
	NVIC_EnableIRQ(EXINT0_7_IRQn);
	NVIC_SetPriority(EXINT0_7_IRQn, FM3_EXTI_PRIORITY);
	NVIC_EnableIRQ(EXINT8_31_IRQn);
	NVIC_SetPriority(EXINT8_31_IRQn, FM3_EXTI_PRIORITY);
}

void PHY_Interrupt(void)
{
	unsigned int reg23;
	unsigned int eirr = FM3_EXTI->EIRR;
	//debug_printf("EIRR %08x\n", eirr);
	FM3_EXTI->EICL &= ~eirr;								// ݗṽNA
	//debug_printf("EIRR %08x\n", FM3_EXTI->EIRR);
	PHY_Read(PHY_ADDR, PHY_REG_23, &reg23, MII_RD_TOUT);	// LINKԂ̎擾
	//debug_printf("PHY23 %08x\n", reg23);
	if (reg23 & 1) {
		debug_printf("PHY: Link Up\n");
	} else if (reg23 & 4) {
		debug_printf("PHY: Link Down\n");
	} else {
		debug_printf("External Interrupt\n");
	}
	PHY_Write(PHY_ADDR, PHY_REG_23, reg23, MII_WR_TOUT);	// LINKԂ̃NA
	//PHY_Read(PHY_ADDR, PHY_REG_23, &reg23, MII_RD_TOUT);
	//debug_printf("PHY23 %08x\n", reg23);
}

#ifdef __GCC__
void INT0_7_Handler(void) __attribute__((interrupt));
#endif
void INT0_7_Handler(void)
{
	PHY_Interrupt();
}

#ifdef __GCC__
void INT8_31_Handler(void) __attribute__((interrupt));
#endif
void INT8_31_Handler(void)
{
	PHY_Interrupt();
}
