/*
 * main.c
 *
 *  Created on: 2012/01/01
 *      Author: Kentaro Sekimoto
 */

/* fm3_sample_ether.hQ */
/* VA`ĺAUART_CHύX */
/* Ethernet`ĺAETH_CH0ETH_CH1` */
#include "common.h"
#include "mcu.h"
#include "fm3_ether.h"
#include "eth.h"
#include "ip.h"
#include "arp.h"
#include "icmp.h"
#include "fm3_uart.h"
#include "debug_printf.h"

#define ARP_PACKET_SIZE 42
#define ICMP_PACKET_SIZE 74
#define CH_MAX	2

// MACAhXIPAhX̐ݒ
unsigned char MyMACAddr[CH_MAX][6] = {
	MY_MAC_ADDR0,
	MY_MAC_ADDR1
};
unsigned char MyIPAddr[CH_MAX][4] = {
	MY_IP_ADDR0,
	MY_IP_ADDR1
};
unsigned char DstMACAddr[6] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
unsigned char DstIPAddr[4] = DST_IP_ADDR;
unsigned char DummyMACAddr[6] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
unsigned char DstMACAddr_Initialized = FALSE;

// MEthenetpPbĝ߂̈ꎞIȃobt@
struct eth_packet ep;

// ========== fobO֘A Jn ===========

void LED_Init(void)
{
#ifdef MB9BF618T
	FM3_GPIO->PFRF &= 0xFFF7;	// PF3 GPIO
	FM3_GPIO->DDRF  |= 0x0008;	// PF3 output
#else
	FM3_GPIO->PFR4 &= 0xFFFE;	// P40 GPIO
	FM3_GPIO->DDR4  |= 0x0001;	// P40 output
#endif
}

void LED_On(void)
{
#ifdef MB9BF618T
	FM3_GPIO->PDORF &= 0xFFF7;	// PF3 low
#else
	FM3_GPIO->PDOR4 &= 0xFFFE;	// P40 low
#endif
}

void LED_Off(void)
{
#ifdef MB9BF618T
	FM3_GPIO->PDORF |= 0x0008;	// PF3 high
#else
	FM3_GPIO->PDOR4 |= 0x0001;	// P40 low
#endif
}

// _v
void Memory_Dump(unsigned long addr, int len)
{
	int i, j;
	char *p = (char *)addr;
	char *q = (char *)addr;
	for (i = 0; i < len; i++) {
		if ((i & 0xf) == 0) {
			debug_printf("%08x ", (unsigned long)p);
		}
		debug_printf("%02x ", (unsigned long)(*p));
		if (((i & 0xf) == 0xf) || (i == (len - 1))) {
			j = 16- (i & 0xf);
			while (j-- > 0)
				debug_printf("   ");
			for (j = 0; j <= (i & 0xf); j++) {
				if (*q >= 0x20 && *q <= 0x7e) {
					debug_printf("%c", *q);
				} else
					debug_printf(" ");
				*q++;
			}
			debug_printf("\r\n");
		}
		p++;
	}
	debug_printf("\r\n");
}
// ========== fobO֘A I ===========

// APRpPbg̏ёM
void ARP_Send(void)
{
#ifdef ETH_CH0
	ARP_Packet(&ep, 1, MyMACAddr[0], MyIPAddr[0], DummyMACAddr, DstIPAddr);
#endif
#ifdef ETH_CH1
	ARP_Packet(&ep, 1, MyMACAddr[1], MyIPAddr[1], DummyMACAddr, DstIPAddr);
#endif
	Packet_Send((unsigned char *)&ep, ARP_PACKET_SIZE);
}

// ICMP ECHO REQUEST pPbg̏ёM
void ICMP_ECHO_REQUEST_Send(void)
{
	unsigned short id = 1;
	unsigned short seqno = 1;
#ifdef ETH_CH0
	ICMP_Packet(&ep, MyMACAddr[0], MyIPAddr[0], DstMACAddr, DstIPAddr, ICMP_ECHO, 0, id, seqno);
#endif
#ifdef ETH_CH1
	ICMP_Packet(&ep, MyMACAddr[1], MyIPAddr[1], DstMACAddr, DstIPAddr, ICMP_ECHO, 0, id, seqno);
#endif
	Packet_Send((unsigned char *)&ep, ICMP_PACKET_SIZE);
}

#if 0
// ԑ҂
static void wait(volatile unsigned int count)
{
	while (count-- > 0) ;
}
#endif

// MpPbg
void RXPacket_Process(void)
{
	unsigned int size;
	EMAC_DMA_RXDESC *prxdesc;
	struct eth_packet *ethp;
	struct etharp_hdr *ethah;
	struct ip_hdr *iph;
	struct icmp_echo_hdr *icmphdr;
	unsigned char ip_proto;

	while ((prxdesc = RXDESC_Received()) != NULL) {
		size = prxdesc->RDES0_f.FL;
		ethp = (struct eth_packet *)prxdesc->RDES2;
#ifdef ETH_CH0
		if (strncmp((void *)&ethp->ehdr.dst.addr, (void *)&MyMACAddr[0], 6) == 0) {
#endif
#ifdef ETH_CH1
		if (strncmp((void *)&ethp->ehdr.dst.addr, (void *)&MyMACAddr[1], 6) == 0) {
#endif
			switch (ntohs(ethp->ehdr.type)) {
			case 0x0800 :
				iph = (struct ip_hdr *)&ethp->data;
				ip_proto = ntohs(iph->ttl_proto) & 0xff;
				//debug_printf("Receiving a IP packet\n");
				switch (ip_proto) {
				case IP_PROTO_ICMP:
					icmphdr = (struct icmp_echo_hdr *)((unsigned int)iph + sizeof(struct ip_hdr));
					if (icmphdr->type == ICMP_ECHO) {
						debug_printf("Receiving Ping Packet\n");
						Memory_Dump((unsigned long)ethp, size);
						memcpy((void *)&ep, (void *)ethp, ICMP_PACKET_SIZE);
						ICMP_ECHO_REPLY_Packet(&ep);
						Packet_Send((unsigned char *)&ep, ICMP_PACKET_SIZE);
						debug_printf("Sending Ping Packet\n");
						Memory_Dump((unsigned long)ethp, size);
					} else if (icmphdr->type == ICMP_ER) {
						debug_printf("Receiving Ping Packet\n");
						Memory_Dump((unsigned long)ethp, size);
					}
					break;
				default:
					debug_printf("protocol %02x\n", ip_proto);
					break;
				}
				break;
			case 0x0806 :
				ethah = (struct etharp_hdr *)&ethp->data;
				debug_printf("Receiving ARP packet\n");
				debug_printf("%d.%d.%d.%d at %02x:%02x:%02x:%02x:%02x:%02x\n",
						DstIPAddr[0], DstIPAddr[1], DstIPAddr[2], DstIPAddr[3],
						ethah->shwaddr.addr[0], ethah->shwaddr.addr[1],ethah->shwaddr.addr[2],
						ethah->shwaddr.addr[3], ethah->shwaddr.addr[4],ethah->shwaddr.addr[5]);
				memcpy((void *)DstMACAddr, (void *)&ethah->shwaddr.addr, 6);
				DstMACAddr_Initialized = TRUE;
				Memory_Dump((unsigned long)ethp, size);
				break;
			default:
				debug_printf("Receiving a unknown packet\n");
				break;
			}
		}
		prxdesc->RDES0_f.OWN = 1;
	}
}

// 1
// ͂Ȃꍇ́A0ԂB
unsigned char get_char(void)
{
	return UART_Rx(UART_CH);
}

// j[\
void Menu_Disp(void)
{
	unsigned int i;

#ifdef ETH_CH0
	i = 0;
#endif
#ifdef ETH_CH1
	i = 1;
#endif
	debug_printf("\n================ FM3 Ethernet Test ===============\n");
	debug_printf("My  IP Addr: %d.%d.%d.%d (%02x:%02x:%02x:%02x:%02x:%02x)\n",
			MyIPAddr[i][0], MyIPAddr[i][1], MyIPAddr[i][2], MyIPAddr[i][3],
			MyMACAddr[i][0], MyMACAddr[i][1], MyMACAddr[i][2], MyMACAddr[i][3], MyMACAddr[i][4], MyMACAddr[i][5]);
	debug_printf("Dst IP Addr: %d.%d.%d.%d \n",
			DstIPAddr[0], DstIPAddr[1], DstIPAddr[2], DstIPAddr[3]);
	debug_printf("The above items are defined in fm3_sample_ether.h\n");
	debug_printf("1. Send ARP Packet  -> 1 key\n");
	debug_printf("2. Send PING Packet -> 2 key\n");
	debug_printf("==================================================\n\n");
}

// EtherneteXg
void TestEther(void)
{
	unsigned char c;
#ifdef ETH_CH0
	Ether_Init((unsigned char *)MyMACAddr[0]);
#endif
#ifdef ETH_CH1
	Ether_Init((unsigned char *)MyMACAddr[1]);
#endif
	Menu_Disp();
	while (1) {
		c = get_char();
		if (c != 0) {
			switch ((int)c) {
			case '0':
				DMA_Register_Dump();
				TXDESC_Dump();
				RXDESC_Dump();
				break;
			case '1':
				debug_printf("Sending ARP Packet\n");
				ARP_Send();
				Memory_Dump((unsigned long)&ep, 42);
				break;
			case '2':
				while (DstMACAddr_Initialized == FALSE) {
					ARP_Send();
					RXPacket_Process();
				}
				debug_printf("Sending PING Packet\n");
				ICMP_ECHO_REQUEST_Send();
				Memory_Dump((unsigned long)&ep, 74);
				break;
			default:
				break;
			}
		}
		RXPacket_Process();
	}
}

// C֐
int main(void)
{
	LED_Init();
	LED_On();
	UART_Init(UART_CH, 115200);
	TestEther();
	while (1) ;
}
