#include "mb9bf618t.h"

#define CS	bFM3_GPIO_PDORC_PC	//PortC-C(CN3-24)
#define SK	bFM3_GPIO_PDORC_PD	//PortC-D(CN3-23)
#define DI	bFM3_GPIO_PDORC_PE	//PortC-E(CN3-20)
#define DO	bFM3_GPIO_PDIRC_PF	//PortC-F(CN3-22)

static int initialized = 0;

static void wait(int t)
{
	volatile int x = 100 * t;

	while(x--);
	return;
}

static void init_gpio(void)
{
	bFM3_GPIO_DDRC_PC = 1;
	bFM3_GPIO_DDRC_PD = 1;
	bFM3_GPIO_DDRC_PE = 1;
	bFM3_GPIO_DDRC_PF = 0;
	bFM3_GPIO_PCRC_PF = 1;

	CS = 0;
	SK = 0;
	DI = 0;

	wait(1000);

	initialized = 1;
	return;
}

static int clock(void)
{
	int data;

	wait(100);
	SK = 1;
	wait(100);
	data = DO ? 1: 0;

	SK = 0;
	wait(100);

	return data;
}

unsigned short short_read(int address)
{
	int i;
	unsigned short data;

	if(!initialized)init_gpio();

	CS = 1;
	DI = 1;
	clock();
	DI = 1;
	clock();
	DI = 0;
	clock();

	for(i = 0; i < 6; i++)
	{
		DI = (address & (1 << 5)) ? 1 : 0;
		clock();
		address <<= 1;
	}

	DI = 0;

	data = 0;
	for(i = 0; i < 16; i++)
	{
		data <<= 1;
		data |= clock();
	}

	CS = 0;

	return data;
}

unsigned char *read_93c46(int add, int len, unsigned char *ucp)
{
	unsigned short *buf = (unsigned short*)ucp;

	add /= 2;
	len /= 2;
	while(len--)
	{
		*buf++ = short_read(add++);
		wait(1000);
	}
	const unsigned char no_address[6] = {0xff, 0xff, 0xff, 0xff, 0xff, 0xff};
	if(0 == memcmp(ucp, no_address, 6))
	{
		//[JMACAhXgp
		const unsigned char local_address[6] = {0x02, 0x00, 0x00, 0x00, 0x00, 0x00};
		memcpy(ucp, local_address, 6);
	}
	return ucp;
}
